import { HttpClientOptions, HttpClientResponse } from "./AdtHTTP";
export interface RequestData {
    method: string;
    uri: string;
    params: Record<string, string>;
    headers: Record<string, string>;
    body?: string;
}
export interface ResponseData {
    headers: Record<string, string>;
    statusCode: number;
    statusMessage: string;
    body?: string;
}
export type LogData = {
    id: number;
    request: RequestData;
    response: ResponseData;
    stateful: boolean;
    startTime: Date;
    duration: number;
    error?: Error;
    clientId: number;
};
export interface LogCallback {
    (data: LogData): void;
}
export declare const logError: (clientId: number, error: unknown, callback: LogCallback | undefined) => void;
export declare const logResponse: (clientId: number, original: HttpClientResponse, config: HttpClientOptions, callback: LogCallback | undefined) => void;
//# sourceMappingURL=requestLogger.d.ts.map